org.eclipse.january.dataset

## Class ShapeUtils

- java.lang.Object
- - org.eclipse.january.dataset.ShapeUtils

-     public class ShapeUtils
      extends Object

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static boolean` | `areShapesBroadcastCompatible(int[] ashape, int[] bshape)` Check if shapes are broadcast compatible
    `static boolean` | `areShapesCompatible(int[] ashape, int[] bshape)` Check if shapes are compatible, ignoring extra axes of length 1
    `static boolean` | `areShapesCompatible(int[] ashape, int[] bshape, int axis)` Check if shapes are compatible but skip axis
    `static long` | `calcLongSize(int[] shape)` Calculate total number of items in given shape
    `static int` | `calcSize(int[] shape)` Calculate total number of items in given shape
    `static void` | `checkCompatibility(ILazyDataset g, ILazyDataset h)` This function takes a dataset and checks its shape against another dataset.
    `static int` | `getFlat1DIndex(int[] shape, int[] pos)` Get flattened view index of given position
    `static int[]` | `getNDPositionFromShape(int n, int[] shape)` Get n-D position from given index
    `static int[]` | `getShapeFromObject(Object obj)` Get shape from object (array or list supported)
    `static int[]` | `squeezeShape(int[] oshape, boolean onlyFromEnds)` Remove dimensions of 1 in given shape - from both ends only, if true
    `static int[]` | `squeezeShape(int[] oshape, int axis)` Remove dimension of 1 in given shape

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### calcLongSize

          public static long calcLongSize(int[] shape)

      Calculate total number of items in given shape
      Parameters:
        `shape` -
      Returns:
        size

    - #### calcSize

          public static int calcSize(int[] shape)

      Calculate total number of items in given shape
      Parameters:
        `shape` -
      Returns:
        size

    - #### areShapesBroadcastCompatible

          public static boolean areShapesBroadcastCompatible(int[] ashape,
                                             int[] bshape)

      Check if shapes are broadcast compatible
      Parameters:
        `ashape` -
        `bshape` -
      Returns:
        true if they are compatible

    - #### areShapesCompatible

          public static boolean areShapesCompatible(int[] ashape,
                                    int[] bshape)

      Check if shapes are compatible, ignoring extra axes of length 1
      Parameters:
        `ashape` -
        `bshape` -
      Returns:
        true if they are compatible

    - #### areShapesCompatible

          public static boolean areShapesCompatible(int[] ashape,
                                    int[] bshape,
                                    int axis)

      Check if shapes are compatible but skip axis
      Parameters:
        `ashape` -
        `bshape` -
        `axis` -
      Returns:
        true if they are compatible

    - #### squeezeShape

          public static int[] squeezeShape(int[] oshape,
                           boolean onlyFromEnds)

      Remove dimensions of 1 in given shape - from both ends only, if true
      Parameters:
        `oshape` -
        `onlyFromEnds` -
      Returns:
        newly squeezed shape (or original if unsqueezed)

    - #### squeezeShape

          public static int[] squeezeShape(int[] oshape,
                           int axis)

      Remove dimension of 1 in given shape
      Parameters:
        `oshape` -
        `axis` -
      Returns:
        newly squeezed shape

    - #### getShapeFromObject

          public static int[] getShapeFromObject(Object obj)

      Get shape from object (array or list supported)
      Parameters:
        `obj` -
      Returns:
        shape can be null if obj is null

    - #### getNDPositionFromShape

          public static int[] getNDPositionFromShape(int n,
                                     int[] shape)

      Get n-D position from given index
      Parameters:
        `n` - index
        `shape` -
      Returns:
        n-D position

    - #### getFlat1DIndex

          public static int getFlat1DIndex(int[] shape,
                           int[] pos)

      Get flattened view index of given position
      Parameters:
        `shape` -
        `pos` - the integer array specifying the n-D position
      Returns:
        the index on the flattened dataset

    - #### checkCompatibility

          public static void checkCompatibility(ILazyDataset g,
                                ILazyDataset h)
                                         throws IllegalArgumentException

      This function takes a dataset and checks its shape against another dataset. If they are both of the same size, then this returns with no error, if there is a problem, then an error is thrown.
      Parameters:
        `g` - The first dataset to be compared
        `h` - The second dataset to be compared
      Throws:
        `IllegalArgumentException` - This will be thrown if there is a problem with the compatibility

Copyright © 2017. All rights reserved.